C    _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C   _/_/  Subprocess function   _/_/
C  _/_/  Date   06/04/2002     _/_/
C _/_/  Author Soushi Tsuno   _/_/
C_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
      function fnc405(x)
      implicit real*8(a-h,o-z)
      real*8   fnc405

      include 'incl4051.h'
      include 'inclk.h'
      include 'grchad.inc'

      parameter ( mxdim = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL

      real*8 ansm, ans
      real*8 x(mxdim),ytmp,ajacob
      external drn

      if (ibsint.lt.2) then
C...Set Parameter for kinematics
         call grcikin

C...Integration/Event Generation : 1/0
         do i = 1, ndim
            xrun(i) = x(i)
         enddo
      endif

C...Set particle combination
      call grcspid
C...Set Particle Masses
      call setmas
C...Set Process
      call g405finit
C...Set Kinematic Variables
      call grcsval

      if (irej.gt.0) then
         if (ibsint.eq.1) inkv = inkv + 1
         go to 999
      endif

C...Set Flavor from Proton/Anti-Proton
      call grcprtngg
C...Fill Kinematics
      ajacob = 0.0d0
      call grcskin(pgrc,ajacob)
      yacob = yacob*ajacob
C...Set Coupling constant
      call grcsene
C...Set Vertex
      call a405mclr
      call amparm

      ansum = 0.0d0
      dft   = 0.d0
      ytmp = yacob

C...Loop over Each Phase Space if necessary
      do 1000 ireg = 1 , mxreg
         yacob = ytmp

C...Swap Particle Combination if necessary
         call grcswap(ireg)
C...Apply Kinematical Cuts
         call grcscut

         do 20 i = 1, 4
            pe4051(i) = pgrc(i, kperm(1))
            pe4052(i) = pgrc(i, kperm(2))
            pe4053(i) = pgrc(i, kperm(3))
            pe4054(i) = pgrc(i, kperm(4))
            pe4055(i) = pgrc(i, kperm(5))
            pe4056(i) = pgrc(i, kperm(6))
 20      continue

C...Set Invariants
         do i=1,6
            do j=1,6
               prod(i,j) = pgrc(4,i)*pgrc(4,j) 
     $              - pgrc(1,i)*pgrc(1,j) 
     $              - pgrc(2,i)*pgrc(2,j) 
     $              - pgrc(3,i)*pgrc(3,j)
            enddo
         enddo

C...Set User Defined Function
         call grcusrfnc405(ireg)
         if (irej.gt.0) go to 1000

C...Calculate Matrix Elements
         call a405kptbl
         call a405mptbl
         call a405mpsum(ansm)

         fknorm = yacob*aspin
         ans    = ansm*fknorm/aident
         ansum  = ansum + ans

C...Store Color String Information
         if (ibsint.eq.2) then
            grcdsig(ireg) = ans
            call sp405detc(ireg)
            call sp405deth(ireg)
         endif
 1000 continue

C...Set Value of Function
      fnc405 = ansum

C...Check Integration
      if (ibsint.eq.1) then
         inbs = inbs + 1
         if (mod(inbs,nfprt).eq.0) then
            write(*,*) inbs
         endif

         if (irej.eq.2) inkc = inkc + 1
         if (irej.eq.3) in4m = in4m + 1
         if (irej.eq.4) inac = inac + 1

         funcmax = max(funcmax,fnc405)
         do i = 1, ndim
            call xhfill(i,x(i),fnc405)
         enddo

         if (funcmax.le.fnc405) then
         endif
      endif

      return
 999  continue
      yacob = 0.0d0
      fnc405 = 0.0d0
      return
      end
