C        _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C       _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C      _/_/ GR@PPA (GRace system @ PP/Anti-p)            _/_/
C     _/_/  File Name  : grchad.inc (Include File)      _/_/
C    _/_/   Date       : Aug.13.2002                   _/_/ 
C   _/_/    Author     : Soushi Tsuno (tsuno@fnal.gov)_/_/ 
C  _/_/     Institute  : Tsukuba Univ. Japan         _/_/
C _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
C###########################
C###  Initial Parameter  ###
C###########################
      integer ibsint,ibswrt,irej,irseed,nzz,nfprt
      common/grcinit1/ibsint,ibswrt,irej,irseed,nzz,nfprt

      real*8 grcecm,funcmax,grcsig
      common/grcinit2/grcecm,funcmax,grcsig(64)

      integer igsub,igpp,inpfl,icoup,ifact,isdep
      common/grcinit3/igsub,igpp,inpfl,icoup,ifact,isdep

      integer ktype,cxtype,nnf,ipx
      common/grcinit4/ktype,cxtype,nnf,ipx(8)

C ibsint = 0 : Event Generation.
C        = 1 : Integration.
C
C ibswrt = 0 : Write output file.
C        = 1 : Already exist.
C
C irej   = 0 : Integration/Event Generation has succeeded.
C        > 0 :                                  failed.
C
C ktype : Kinematics Type.
C       = 1  : 2-body
C       = 2  : 3-body, Q^2(45) is NOT a resonance(glu/gam splitting) 
C       = 3  :         Q^2(45) is a resonance production(W+-, Z, top)
C       = 4  :         Fusion Process, 3 + (45)
C       = 5  : 4-body, Q^2(34) : reso.,     Q^2(56) : non-reso..
C       = 6  :         Q^2(34) : non-reso., Q^2(56) : non-reso..
C       = 7  :         Q^2(34) : reso.,     Q^2(56) : reso..
C       = 8  :         Cascade Decay, (345) + 6 -> 5 + (34) + 6
C       = 9  :         Fusion Process, (34) + 5 + 6
C       = 10 : 5-body, Fusion Process, 3 + (45) + (67)
C       = 11 : 6-body, {3 + (45)} + {6 + (78)}, (45),(78) : reso..
C
C cxtype : Particle Combination Type.
C       = 1  : 2-body, 3 + 4        => Default
C       = 2  : 3-body, 3 + (45)     => Default
C       = 3  :         4 + (35)
C       = 4  :         5 + (34)
C       = 5  : 4-body, (34) + 5 + 6    => Default
C       = 6  :         (34) + 6 + 5
C       = 7  :         (35) + 4 + 6
C       = 8  :         (35) + 6 + 4
C       = 9  :         (36) + 4 + 5
C       = 10 :         (36) + 5 + 4
C       = 11 :         (45) + 3 + 6
C       = 12 :         (45) + 6 + 3
C       = 13 :         (46) + 3 + 5
C       = 14 :         (46) + 5 + 3
C       = 15 :         (56) + 3 + 4
C       = 16 :         (56) + 4 + 3
C       = 17 : 5-body  3 + (45) + (67)
C       = 18 : 6-body  {3 + (45)} + {6 + (78)}
C
C nnf     : Total Num. of particles considered in ME.
C ipx(8)  : Particle ID Num. depending on ktype and cxtype.
C
C irseed,nzz : Seed for random number using standalone mode.
C nfprt   : Print the number showing the status of BASES integration.
C
C grcecm  : CM Energy (GeV) (= sqrt(s)).
C funcmax : Maximum Value of Differencial Cross Section.
C grcsig  : Total Cross Section.
C igsub   : Process ID.
C igpp    : Collision particles PP/PAP. : pp/ppbar : 0/1
C inpfl   : Number of flavor from PDF. (Default = 4)
C
C icoup   : Set Energy Scale (Coupling Q^2).
C           if icoup = 1  ==> Q^2 = s^ for parton scale
C                    = 2  ==> Q^2 = average value of transverse mass^2
C                    = 3  ==> Q^2 = total transverse mass^2
C                    = 4  ==> Q^2 = maximum transverse mass^2
C                    = 5  ==> Q^2 = constant value
C                            (Set grcq in GeV order)
C                    = 6  ==> user defined Q^2 (set GRCUSRSETQ)
C           Note : if ifact = 0, Factorization scale is set 
C                  the same as the renormalization scale.
C
C ifact   : Choice of  the factorization scale.
C           if ifact = 0 ==> same as the renormalization scale. (see icoup)
C                    = 1  ==> Q^2 = s^ for parton scale
C                    = 2  ==> Q^2 = average value of transverse mass^2
C                    = 3  ==> Q^2 = total transverse mass^2
C                    = 4  ==> Q^2 = maximum transverse mass^2
C                    = 5  ==> Q^2 = constant value
C                            (Set grcfaq in GeV order)
C                    = 6  ==> user defined Q^2 (set GRCUSRSETQ)
C
C isdep = 1 : s^-dependence of the resonance production.
C
C#########################################
C###  Cut Parameter for Each Particle  ###
C#########################################
      real*8 grcptcut,grcetacut,grcrconcut,grcmetcut
      common/grccut1/grcptcut(6),grcetacut(6),grcrconcut(6),grcmetcut
      real*8 gptcut,getacut,grconcut
      common/grccut2/gptcut,getacut,grconcut

C Default ==> without any cuts
C 
C grcptcut(i)   : Pt cut for i-th Final State Particles.
C grcetacut(i)  : Eta cut for i-th Final State Particles.
C grcrconcut(i) : Rcone cut (= sqrt(dPhi(i,j)**2+dEta(i,j)**2)  j=1,2,3..).
C                                      for i-th Final State Particles.
C grcmetcut     : Missing Pt(Et) cut.
C
C gptcut        : Pt cut applied for all Final State Particles.
C getacut       : Eta cut applied for all Final State Particles.
C grconcut      : Rcone cut applied for all Final State Particles.

C####################################################################
C###  4-Momemtum of Each Particle and Differencial Cross Section  ###
C####################################################################
      real*8 pgrc,plgrc,pqgrc,grcdsig,grcq,grcfaq
      common/grcmon1/pgrc(4,8),plgrc(4,8),pqgrc(4,4),grcdsig(32),
     $     grcq,grcfaq

      integer grchlc
      common/grcmon2/grchlc(8)

C pgrc(4,i)  : 4-Momentum (px,py,pz,E) of i-th Particle.
C plgrc(4,i) : 4-Momentum (pt,phi,eta,E) of i-th Particle for Final State.
C                         (px,py,pz,E)                    for Initial.
C pqgrc(4,i) : 4-Momentum (px,py,pz,E) of intermediate Particle.
C grcdsig    : Differencial Cross Section.
C grcq       : Energy scale of the process (renormalization scale).
C grcfaq     : Factorization scale of the process.
C
C grchlc(i)  : Helicity state of i-th Particle.

C###################################################
C###  Initial Parameter of Kinematical Variable  ###
C###################################################
      real*8 gtau,gyst,gcos3,gq12,gq22,gcon,gspr,geps
      common/grcpar1/gtau(18),gyst(18),gcos3(18),gq12(18),gq22(18),
     $               gcon(5),gspr(5),geps(5)

C gtau(1),gyst(1),gcos3(1),gq12(1),gq22(1)
C           : Number of Function of Each Variable (Tau,Yst,Cos,Q12,and Q22).
C
C gtau(2),gyst(2),gcos3(2),gq12(2),gq22(2)
C           : Minimum Value of Each Variable.
C
C gtau(3-7),gyst(3-7),gcos3(3-7),gq12(3-7),gq22(3-7)
C           : Maximum Value of Each Function for Each Variable.
C
C gtau(8-13),gyst(8-13),gcos3(8-13),gq12(8-13),gq22(8-13)
C           : Maximum Region of Random Number for Each Function.
C
C gtau(14-18),gyst(14-18),gcos3(14-18),gq12(14-18),gq22(14-18)
C           : Function Type for Each Region.
C
C gcon : Cos Tunning Parameter.
C gspr : Subsystem Cosine Function Type.
C geps : Tunning Parameter of Subsystem Cosine Function.

C###############################
C###  Kinematical Variables  ###
C###############################
      real*8 xrun,gpri,gval,yacob
      common/grcfunc/xrun(32),gpri(10),gval(32),yacob

      integer grcflav,grcireg,grcicol,grcihel
      common/grcfunc1/grcflav,grcireg,grcicol(8),grcihel(8)

C grcflav : Flavor ID from proton/anti-proton.
C  _______________________
C | Initial |             |
C |  State  | gluon,gluon |
C +=========+=============+
C | grcflav |      0      |
C +---------+-------------+
C  _____________________________________________________________________
C | Initial |  _ |  _ |  _ |  _ | _  | _  | _  | _  |  _ | _  |  _ | _  |
C |  State  | uu | dd | cc | ss | uu | dd | cc | ss | bb | bb | tt | tt |
C +=========+====+====+====+====+====+====+====+====+====+====+====+====+
C | grcflav |  1 |  2 |  3 |  4 |  5 |  6 |  7 |  8 |  9 | 10 | 11 | 12 |
C +---------+----+----+----+----+----+----+----+----+----+----+----+----+
C            _______________________________________
C           |  _ |  _ |  _ |  _ | _  | _  | _  | _  |
C           | uc | ds | cu | sd | uc | ds | cu | sd |
C           +====+====+====+====+====+====+====+====+
C           | 133| 134| 135| 136| 137| 138| 139| 140|
C           +----+----+----+----+----+----+----+----+
C b-content  _______________________________________
C           |  _ |  _ |  _ |  _ | _  | _  | _  | _  |
C           | db | sb | bd | bs | bd | bs | db | sb |
C           +====+====+====+====+====+====+====+====+
C           | 141| 142| 143| 144| 145| 146| 147| 148|
C           +----+----+----+----+----+----+----+----+
C top-content_______________________________________
C           |  _ |  _ |  _ |  _ | _  | _  | _  | _  |
C           | ut | ct | tu | tc | ut | ct | tu | tc |
C           +====+====+====+====+====+====+====+====+
C           | 149| 150| 151| 152| 153| 154| 155| 156|
C           +----+----+----+----+----+----+----+----+
C  _________________________________________________
C | Initial |  _ |  _ | _  | _  | _  | _  |  _ |  _ |
C |  State  | ud | cs | du | sc | ud | cs | du | sc |
C +=========+====+====+====+====+====+====+====+====+
C | grcflav | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 |
C +---------+----+----+----+----+----+----+----+----+
C  _________________________________________________
C | Initial |  _ |  _ | _  | _  | _  | _  |  _ |  _ |
C |  State  | us | cd | su | dc | us | cd | su | dc |
C +=========+====+====+====+====+====+====+====+====+
C | grcflav | 21 | 22 | 23 | 24 | 25 | 26 | 27 | 28 |
C +---------+----+----+----+----+----+----+----+----+
C            _______________________________________
C           |  _ |  _ | _  | _  | _  | _  |  _ |  _ |
C           | ub | cb | bu | bc | ub | cb | bu | bc |
C           +====+====+====+====+====+====+====+====+
C           | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 |
C           +----+----+----+----+----+----+----+----+
C  _________________________________________________
C | Initial |    |    |    |    | _  | _  | _  | _  |
C |  State  | ug | dg | cg | sg | ug | dg | cg | sg |
C +=========+====+====+====+====+====+====+====+====+
C | grcflav | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 |
C +---------+----+----+----+----+----+----+----+----+
C            _______________________________________
C           |    |    |    |    |  _ |  _ |  _ |  _ |
C           | gu | gd | gc | gs | gu | gd | gc | gs |
C           +====+====+====+====+====+====+====+====+
C           | 45 | 46 | 47 | 48 | 49 | 50 | 51 | 52 |
C           +----+----+----+----+----+----+----+----+
C            _______________________________________
C           |    | _  |    |  _ |    | _  |    |  _ |
C           | bg | bg | gb | gb | tg | tg | gt | gt |
C           +====+====+====+====+====+====+====+====+
C           | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 |
C           +----+----+----+----+----+----+----+----+
C  _____________________________________________________________________
C | Initial |    |    |    |    | __ | __ | __ | __ |    | __ |    | __ |
C |  State  | uu | dd | cc | ss | uu | dd | cc | ss | bb | bb | tt | tt |
C +=========+====+====+====+====+====+====+====+====+====+====+====+====+
C | grcflav | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 |
C +---------+----+----+----+----+----+----+----+----+----+----+----+----+
C            _______________________________________
C           |    |    |    |    | __ | __ | __ | __ |
C           | uc | ds | cu | sd | uc | ds | cu | sd |
C           +====+====+====+====+====+====+====+====+
C           | 73 | 74 | 75 | 76 | 77 | 78 | 79 | 80 |
C           +----+----+----+----+----+----+----+----+
C            _______________________________________
C           |    |    |    |    | __ | __ | __ | __ |
C           | bd | bs | db | sb | bd | bs | db | sb |
C           +====+====+====+====+====+====+====+====+
C           | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 |
C           +----+----+----+----+----+----+----+----+
C            _______________________________________
C           |    |    |    |    | __ | __ | __ | __ |
C           | tu | tc | ut | ct | tu | tc | ut | ct |
C           +====+====+====+====+====+====+====+====+
C           | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 |
C           +----+----+----+----+----+----+----+----+
C
C subroutine grcprtnqqs
C  _________________________________________________
C | Initial |    |    |    |    |    |    |    |    |
C |  State  | ud | us | cd | cs | du | dc | su | sc |
C +=========+====+====+====+====+====+====+====+====+
C | grcflav | 97 | 98 | 99 | 100| 101| 102| 103| 104|
C +---------+----+----+----+----+----+----+----+----+
C            _______________________________________
C           | __ | __ | __ | __ | __ | __ | __ | __ |
C           | ud | us | cd | cs | du | dc | su | sc |
C           +====+====+====+====+====+====+====+====+
C           | 105| 106| 107| 108| 109| 110| 111| 112|
C           +----+----+----+----+----+----+----+----+
C            _______________________________________
C           |    |    |    |    | __ | __ | __ | __ |
C           | ub | cb | bu | bc | ub | cb | bu | bc |
C           +====+====+====+====+====+====+====+====+
C           | 113| 114| 115| 116| 117| 118| 119| 120|
C           +----+----+----+----+----+----+----+----+
C            ___________________________________________________________
C           |    |    |    |    |    |    | __ | __ | __ | __ | __ | __ |
C           | td | ts | tb | dt | st | bt | td | ts | tb | dt | st | bt |
C           +====+====+====+====+====+====+====+====+====+====+====+====+
C           | 121| 122| 123| 124| 125| 126| 127| 128| 129| 130| 131| 132|
C           +----+----+----+----+----+----+----+----+----+----+----+----+
C
C grcireg : Swich parameter for phase space.
C grcicol : Color State for Color String of PYTHIA.
C
C xrun : Random Number for Integration and Event Generation.
C        if init = 1   ==> Integration
C                = 2   ==> Event Generation
C
C gpri : Most Primitive Variables for All Processes.
C            gpri(1)  : tau (= x1*x2)           using xrun(1)
C            gpri(2)  : yst (= 0.5*log(x1/x2))        xrun(2)
C            gpri(3)  : s^ (= (E1 + E2)^2)
C            gpri(4)  : w^ (= sqrt(s^))
C            gpri(5)  : x1 from particle 1 side
C            gpri(6)  : x2 from particle 2 side
C            gpri(7)  : beta
C            gpri(8)  : gamma
C            gpri(9)  : energy scale (in GeV order)
C            gpri(10) : Random Number to decide Initial Flavor
C                             using xrun(Last Num. of NDIM ==> see grcpar.f)
C
C gval : Kinematical Variables for Each Processes.
C
C   2-Body case (Ktype = 1)
C            gval(1)  : cos(theta)    using xrun(3)
C            gval(2)  : phi                 xrun(4)
C            gval(3)  : Pt of particle 3 (additional parameter)
C
C   3-Body case
C        Ktype = 2,3 (clustered mass)
C            gval(1)  : cos(theta_12)               using xrun(3)
C            gval(2)  : phi_12                            xrun(4)
C            gval(3)  : Q^2                               xrun(5)
C            gval(4)  : cos(theta) in Q^2 CM frame        xrun(6)
C            gval(5)  : phi        in Q^2 CM frame        xrun(7)
C            gval(6)  : Pt of Q^2 (additional parameter)
C            gval(7)  : Mass with s-dependence width(additional parameter)
C
C        Ktype = 4 (fusion) (1 -> j+A, 2 -> k+B, A+B -> i)
C            gval(1)  : E_i                         using xrun(3)
C            gval(2)  : E_j - E_k                         xrun(4)
C            gval(3)  : cos_j                             xrun(5)
C            gval(4)  : cos_k                             xrun(6)
C            gval(5)  : phi_j                             xrun(7)
C
C   4-Body case
C        Ktype = 5,6,7 (clustered mass) (1+2 -> (ij) + (kl))
C            gval(1)  : cos(theta_12)               using xrun(3)
C            gval(2)  : phi_12                            xrun(4)
C            gval(3)  : Q^2(ij)                           xrun(5)
C            gval(4)  : Q^2(kl)                           xrun(6)
C            gval(5)  : cos_ij in Q^2(ij) CM frame        xrun(7)
C            gval(6)  : phi_ij in Q^2(ij) CM frame        xrun(8)
C            gval(7)  : cos_kl in Q^2(kl) CM frame        xrun(9)
C            gval(8)  : phi_kl in Q^2(kl) CM frame        xrun(10)
C
C        Ktype = 8 (cascade) (1+2 -> (ijk) + l -> (ij) + k + l)
C            gval(1)  : cos(theta_12)               using xrun(3)
C            gval(2)  : phi_12                            xrun(4)
C            gval(3)  : Q^2(ij)                           xrun(5)
C            gval(4)  : Q^2(ijk)                          xrun(6)
C            gval(5)  : cos_ij in Q^2(ij) CM frame        xrun(7)
C            gval(6)  : phi_ij in Q^2(ij) CM frame        xrun(8)
C            gval(7)  : cos_(ij)k in Q^2((ij)k) CM frame  xrun(9)
C            gval(8)  : phi_(ij)k in Q^2((ij)k) CM frame  xrun(10)
C
C        Ktype = 9 (fusion) (1 -> k+A, 2 -> l+B, A+B -> i+j)
C            gval(1)  : E_(ij)                      using xrun(3)
C            gval(2)  : E_k - E_l                         xrun(4)
C            gval(3)  : cos_k                             xrun(8)
C            gval(4)  : cos_l                             xrun(6)
C            gval(5)  : phi_k                             xrun(7)
C            gval(6)  : Q^2(ij)                           xrun(5)
C            gval(7)  : cos_(ij) in Q^2(ij) CM frame      xrun(9)
C            gval(8)  : phi_(ij) in Q^2(ij) CM frame      xrun(10)
C
C   5-Body case
C        Ktype = 10 (fusion) (1-> A+B, 2-> C+D, B+D -> 3, A -> 4+5, C -> 6+7)
C            gval(1)  : E_A + E_C                   using xrun(3)
C            gval(2)  : E_A - E_C                         xrun(4)
C            gval(3)  : Q^2(45)                           xrun(5)
C            gval(4)  : Q^2(67)                           xrun(6)
C            gval(5)  : cos_A                             xrun(7)
C            gval(6)  : cos_C                             xrun(8)
C            gval(7)  : phi_A                             xrun(9)
C            gval(8)  : cos_(45) in Q^2(45) CM frame      xrun(10)
C            gval(9)  : phi_(45) in Q^2(45) CM frame      xrun(11)
C            gval(10) : cos_(67) in Q^2(67) CM frame      xrun(12)
C            gval(11) : phi_(67) in Q^2(67) CM frame      xrun(13)
C            gval(12) : P_A
C            gval(13) : P_C
C            gval(14)  : Mass with s-dependence width(additional parameter)
C
C        Ktype = 11 (clustered mass) (1+2 -> (34) + (56) + 7)
C            gval(1)  : P34 + P56                   using xrun(3)
C            gval(2)  : P34 - P56                         xrun(4)
C            gval(3)  : Q^2(34)                           xrun(5)
C            gval(4)  : Q^2(56)                           xrun(6)
C            gval(5)  : cos_7                             xrun(7)
C            gval(6)  : cos_56                            xrun(8)
C            gval(7)  : phi_7                             xrun(9)
C            gval(8)  : cos_(34) in Q^2(34) CM frame      xrun(10)
C            gval(9)  : phi_(34) in Q^2(34) CM frame      xrun(11)
C            gval(10) : cos_(56) in Q^2(56) CM frame      xrun(12)
C            gval(11) : phi_(56) in Q^2(56) CM frame      xrun(13)
C
C        Ktype = 12 (cascade) (1+2 -> (34) + (567) -> (34) + (56) + 7
C            gval(1)  : cos(theta_12)               using xrun(3)
C            gval(2)  : phi_12                            xrun(4)
C            gval(3)  : Q^2(34)                           xrun(5)
C            gval(4)  : Q^2(56)                           xrun(6)
C            gval(5)  : Q^2(567)                          xrun(7)
C            gval(6)  : cos_567                           xrun(8)
C            gval(7)  : phi_567                           xrun(9)
C            gval(8)  : cos_(34) in Q^2(34) CM frame      xrun(10)
C            gval(9)  : phi_(34) in Q^2(34) CM frame      xrun(11)
C            gval(10) : cos_(56) in Q^2(56) CM frame      xrun(12)
C            gval(11) : phi_(56) in Q^2(56) CM frame      xrun(13)
C
C   6-Body case
C        Ktype = 13 (clustered mass) (1+2 -> (345) + (678) -> 3+(45) + 6+(78))
C            gval(1)  : cos(theta_12)               using xrun(3)
C            gval(2)  : phi_12                            xrun(4)
C            gval(3)  : Q^2{3(45)}                        xrun(5)
C            gval(4)  : Q^2{6(78)}                        xrun(6)
C            gval(5)  : cos_3 in Q^2{3(45)} CM frame      xrun(7)
C            gval(6)  : phi_3 in Q^2{3(45)} CM frame      xrun(8)
C            gval(7)  : cos_6 in Q^2{6(78)} CM frame      xrun(9)
C            gval(8)  : phi_6 in Q^2{6(78)} CM frame      xrun(10)
C            gval(9)  : Q^2(45)                           xrun(11)
C            gval(10) : Q^2(78)                           xrun(12)
C            gval(11) : cos_45 in Q^2(45) CM frame        xrun(13)
C            gval(12) : phi_45 in Q^2(45) CM frame        xrun(14)
C            gval(13) : cos_78 in Q^2(78) CM frame        xrun(15)
C            gval(14) : phi_78 in Q^2(78) CM frame        xrun(16)
C
C yacob : Jacobian of Phase Space.

C#####################
C###  Decay Table  ###
C#####################
      integer igzdcy,igwdcy,igjflv
      common/grcdcy1/igzdcy(32),igwdcy(40),igjflv(8)

      real*8 gwdcyms,grczbr,grcwbr,grcckm
      common/grcdcy2/gwdcyms(16),grczbr(16),grcwbr(20),grcckm(4,4)

      integer igndcy,gdcypr1,gdcypr2
      common/grcidcy/igndcy,gdcypr1(400),gdcypr2(400)

      real*8 gdcysum,gdcyrat
      common/grcddcy/gdcysum,gdcyrat(400)

      integer igrcgef
      common/grcfdcy/igrcgef

C igzdcy/igwdcy   : KF codes of Z/W decay products.
C igjflv          : Activate on jet flavor : ON/OFF:1/0, for d/u/s/c/b/t/g. 
C gwdcyms         : Masses of W decay products, only valid for 4-body ME.
C grczbr/grcwbr   : Br. ratio of Z/W.
C grcckm          : CKM matrix.
C igndcy          : Number of allowed-decay mode of W and Z.
C gdcypr1/gdcypr2 : Allowed decay mode.
C gdcysum         : Summation of allowed decay Br. ratio.
C gdcyrat         : Ratio for allowed decay Br. ratio.
C igrcgef         : include photon interference in Z propagation, ON/OFF:1/0.

C#########################
C###  Check Parameter  ###
C#########################
      integer inbs,inkv,inkc,in4m,inac
      common/grcchk/inbs,inkv,inkc,in4m,inac

C inbs : Status Number of Integration
C inkv : Failed to set Kinematical Variables
C inkc : Failed to pass Kinematical Cuts
C in4m : Failed to set 4-momemtum for each particle
C inac : Failed Additional Constraint

