C Program : sample_alone.F
C Purpose : Sample code for standalone
C Date    : Jan.24.2003
C Author  : Soushi Tsuno

C Only one subprocess (ISUB = 401) is activated in this example.

C...All real arithmetic in double precision.
      implicit double precision(a-h,o-z)

#include "define.h"

C...Include GR@PPA common parameter.
      include 'grchad.inc'

C...PDF common parameter.
      CHARACTER*20      PARM(20)
      DOUBLE PRECISION  VALUE(20)

C...Set Ntuple-----------------------------------------------------
      integer nwpawc
      parameter (nwpawc=300000)
      common/pawc/paw(nwpawc)
      integer neve,psub
      real pj
      common/genep/neve,psub,pj(5,6)

      call hlimit(nwpawc)
      call hropen(1,'genep','bbbb_tev_alone.nt','N',4095,istat)
      call hbnt(10,'genep',' ')
      call hbname(10,'genep',neve,'neve:i,psub:i,pj(5,6):r')
C-----------------------------------------------------------------

C...Number of events and cm energy. 
      nev = 1000            ! Number of events

C...CM energy. 
      GRCECM = 1960.0D0         ! CM Energy

C...Event ID
      IPROC = 401

C...Kinematical cuts.
      GPTCUT   = 10.0D0         ! Pt Cut for each particles
      GETACUT  = 2.5D0          ! Eta Cut
      GRCONCUT = 0.4D0          ! RCone Cut

C...Set seeds for random numbers.
      IRSEED = 12345
      NZZ = 2147483647

C...Set PDF.
#if PDFLIB == 1
C...This flag is only available for PYTHIA.

#elif PDFLIB == 2
C...Initialization of PDFLIB.
      PARM(1) = 'Init0'
      VALUE(1) = 0.0d0
      CALL PDFSET(PARM, VALUE)

C...Set PDF's of incoming beams: CTEQ 4L.
      PARM(1) = 'Nptype'
      VALUE(1) = 1
      PARM(2) = 'Ngroup'
      VALUE(2) = 4
      PARM(3) = 'Nset'
      VALUE(3) = 32
C      PARM(4) = 'LO'
C      VALUE(4) = 1
C      PARM(5) = 'NFL'
C      VALUE(5) = 5
C      PARM(6) = 'QCDL5'
C      VALUE(6) = 0.181d0
      CALL PDFSET(PARM, VALUE)

#elif PDFLIB == 3
C...Initialization of LHA PDF
      CALL InitPDFset('cteq6.LHpdf')
      CALL InitPDF(0)
#endif

C...GR@PPA_4b initialization (BASES integration).
      CALL GRCPYGEN('PAP',IPROC,1,SIGMAX)

C...Event loop.
      do iev = 1,nev

C...Event generation.
         CALL GRCPYGEN(' ',IPROC,0,SIGEV)

         if (mod(iev,1000).eq.0) then
            write(*,*) iev
         endif

C...Data Store.

C...Event Nr..
         neve = iev
C...Process ID.
         psub = isub

C...Set Particle 1,2 (x,y,z) and 3,4,5,6 (pt,phi,eta).
         do i = 1,6
            do j = 1,4
               pj(j,i) = plgrc(j,i)
            enddo
            pj(5,i) = 0
         enddo

C...Fill ntuple.
         call hfnt(10)

C...End of loop over events.
      enddo

C...Close ntuple.
      call hrout(10,genep,' ')
      call hrend('genep')

      end
